// Inclusion des librairies nécessaires pour l'horloge et la carte SD

#include <Wire.h>
#include "RTClib.h"

RTC_DS1307 RTC;

#include <SD.h>

// Chip select de la carte SD (bus SPI)
const int chipSelect = 10;

void setup()
{
  // Initialisation horloge  
  Serial.print("Initializing RTC...");
  Wire.begin();
  RTC.begin();

  // Message d'erreur en cas de problème sur la RTC
  if (! RTC.isrunning()) 
  {
    Serial.println("RTC is NOT running!");
  }
  
  // ajustement date & heure suivant paramètres système
  RTC.adjust(DateTime(__DATE__, __TIME__));
  DateTime now = RTC.now();
  
  // Impression date & heure sur moniteur série
  Serial.print(now.year(), DEC);
  Serial.print('/');
  Serial.print(now.month(), DEC);
  Serial.print('/');
  Serial.print(now.day(), DEC);
  Serial.print(' ');
  Serial.print(now.hour(), DEC);
  Serial.print(':');
  Serial.print(now.minute(), DEC);
  Serial.print(':');
  Serial.print(now.second(), DEC);
  Serial.println();
  
  Serial.print(" since midnight 1/1/1970 = ");
  Serial.print(now.unixtime());
  Serial.print("s = ");
  Serial.print(now.unixtime() / 86400L);
  Serial.println("d");
    
  Serial.println();
  delay(3000);
  
  // Initialisation carte SD
  Serial.print("Initializing SD card...");
  pinMode(10, OUTPUT);
  
  // Message d'erreur et arrêt programme en cas de problème sur la carte SD
  if (!SD.begin(chipSelect)) {
    Serial.println("Card failed, or not present");
    return;
  }
  Serial.println("card initialized.");
}

void loop()
{
  // Chaîne de caractères contenant les données en provenance du capteur
  String dataString = "";

  // Lecture des trois capteurs et mise en forme des données
  for (int analogPin = 0; analogPin < 3; analogPin++) 
  {
    int sensor = analogRead(analogPin);
    dataString += String(sensor);
    if (analogPin < 2) 
    {
      dataString += ","; 
    }
  }

  // Ouverture du fichier
  File dataFile = SD.open("datalog.txt", FILE_WRITE);

  // Ecriture
  if (dataFile) 
  {
    dataFile.println(dataString);
    dataFile.close();
    // envoi données sur liaison série
    Serial.println(dataString);
  }  
  // Message d'erreur en cas de problème d'écriture
  else 
  {
    Serial.println("error opening datalog.txt");
  } 
}









